unit parse;

interface

uses windows,messages;

type regi = record
      slash:array of tpoint;
      gklam:array of tpoint;
      zstri:array of tpoint;
      stern:array of tpoint;
end;

var region:regi;
    kwords:array[0..97] of string =
          ('on', //thx to nico for the hint to on ;-)
          'and',
          'begin',
          'constructor',
          'do',
          'except',
          'finally',
          'if',
          'initialization',
          'label',
          'not',
          'out',
          'property',
          'resourcestring',
          'string',
          'try',
          'uses',
          'array',
          'case',
          'destructor',
          'downto',
          'exports',
          'for',
          'implementation',
          'inline',
          'library',
          'object',
          'packed',
          'raise',
          'set',
          'then',
          'type',
          'var',
          'as',
          'class',
          'dispinterface',
          'else',
          'file',
          'function',
          'in',
          'interface',
          'mod',
          'of',
          'procedure',
          'record',
          'shl',
          'threadvar',
          'unit',
          'while',
          'asm',
          'const',
          'div',
          'end',
          'finalization',
          'goto',
          'inherited',
          'is',
          'nil',
          'or',
          'program',
          'repeat',
          'shr',
          'to',
          'until',
          'with',
          'absolute',
          'abstract',
          'assembler',
          'automated',
          'cdecl',
          'dynamic',
          'forward',
          'name',
          'override',
          'readonly',
          'resident',
          'virtual',
          'contains',
          'export',
          'implements',
          'near',
          'package',
          'public',
          'register',
          'safecall',
          'write',
          'default',
          'external',
          'index',
          'nodefault',
          'pascal',
          'published',
          'reintroduce',
          'stdcall',
          'writeonly',
          'private',
          'protected',
          'overload');

function formatiere(var rtext:string):string;

implementation

{a modified version of the string function pos, retrieved from an algorithms book.
 Many thx to BIG KING M, which made the work for me}
function such (const text,suchtext : string; const startposition : longint ) : longint;
var lt,ls,i,j,ende : longint;
    lastchar : char;
    gefunden : boolean;
begin
 lt:=length(text);
 ls:=length(suchtext);
 ende:=lt-ls;
 if startposition>ende then
  begin
    result:=-1;
    exit;
  end;
 i:=startposition+ls-1;
 lastchar:=suchtext[length(suchtext)];
 gefunden:=false;
 while (i<lt) and (gefunden=false) do
  begin
    if text[i]<>lastchar then inc(i)
    else
     begin
       j:=0;
       repeat
         inc(j);
       until (j>ls) or (text[i-j]<>suchtext[ls-j]);
       if j>ls-1 then
        begin
          gefunden:=true;
          dec(j);
        end
        else inc(i);
     end;
  end;
 if gefunden then result:=i-j else result:=-1;
end;

{the function searches all (*..*) combinations in the text and writes these in a dynamic array}
function such_sterne(var text:string):string;
var stapos   :longint;
    endpos   :longint;
    actpos   :longint;
    keyword  :string;
    counter  :longint;
    num      :longint;
begin
 num:=0;
 keyword:='(*';
 stapos:=0;
 endpos:=length(text);
  repeat
   actpos:=such(text,keyword,stapos);
   if actpos <> -1 then
     begin
       inc(num);
       Setlength(region.stern,num);
       region.stern[num-1].x:=actpos;
       counter:=actpos;
       repeat
        inc(counter);
       until ((text[counter]='*') and (text[counter+1]=')')) or (counter=length(text)-1);
       region.stern[num-1].y:=counter;
       stapos:=actpos+2;
     end;
 until actpos=-1;
 result:=text;
end;

{the function searches all '..' combinations in the text and writes these in a dynamic array}
function such_zstris(var text:string):string;
var stapos   :longint;
    endpos   :longint;
    actpos   :longint;
    keyword  :string;
    counter  :longint;
    num      :longint;
begin
 num:=0;
 counter:=0;
 keyword:='''';
 stapos:=0;
 endpos:=length(text);
  repeat
   actpos:=such(text,keyword,stapos);
   if actpos <> -1 then
     begin
       if not odd(counter) then
        begin
          inc(num);
          Setlength(region.zstri,num);
          region.zstri[num-1].x:=actpos;
        end
        else region.zstri[num-1].y:=actpos;
       stapos:=actpos+1;
       inc(counter);
     end;
  until actpos=-1;
 result:=text;
end;

{the function searches all {..} {combinations in the text and writes these in a dynamic array}
function such_gklams(var text:string):string;
var stapos   :longint;
    endpos   :longint;
    actpos   :longint;
    keyword  :string;
    counter  :longint;
    num      :longint;
begin
 num:=0;
 keyword:='{';
 stapos:=0;
 endpos:=length(text);
  repeat
   actpos:=such(text,keyword,stapos);
   if actpos <> -1 then
     begin
       inc(num);
       Setlength(region.gklam,num);
       region.gklam[num-1].x:=actpos;
       counter:=actpos;
       repeat
        inc(counter);
       until (text[counter]='}') or (counter=length(text));
       region.gklam[num-1].y:=counter;
       stapos:=actpos+2;
     end;
 until actpos=-1;
 result:=text;
end;

{the function searches all // in the text and writes these in a dynamic array}
function such_slashs(var text:string):string;
var stapos   :longint;
    endpos   :longint;
    actpos   :longint;
    keyword  :string;
    counter  :longint;
    num      :longint;
begin
 num:=0;
 keyword:='//';
 stapos:=0;
 endpos:=length(text);
  repeat
   actpos:=such(text,keyword,stapos);
   if actpos <> -1 then
     begin
       inc(num);
       Setlength(region.slash,num);
       region.slash[num-1].x:=actpos;
       counter:=actpos;
       repeat
        inc(counter);
       until (text[counter]=#13) or (counter=length(text));
       region.slash[num-1].y:=counter;
       stapos:=actpos+2;
     end;
 until actpos=-1;
 result:=text;
end;

{calculate all regions again, a region is for example '..'}
function setze_regionen(var text:string):boolean;
begin
 SetLength(region.slash,0);
 SetLength(region.gklam,0);
 SetLength(region.zstri,0);
 SetLength(region.stern,0);
 such_slashs(text);
 such_gklams(text);
 such_zstris(text);
 such_sterne(text);
end;

{tests, if the first letter of a keyword is in a region}
function IsInaRegion(cpos:longint):boolean;
var i:longint;
begin
result:=false;
 for i:=0 to high(region.slash) do if (cpos>=region.slash[i].x) and (cpos<=region.slash[i].y) then result:=true;
 for i:=0 to high(region.gklam) do if (cpos>=region.gklam[i].x) and (cpos<=region.gklam[i].y) then result:=true;
 for i:=0 to high(region.zstri) do if (cpos>=region.zstri[i].x) and (cpos<=region.zstri[i].y) then result:=true;
 for i:=0 to high(region.stern) do if (cpos>=region.stern[i].x) and (cpos<=region.stern[i].y) then result:=true;
end;

{tests, if there are letters or numbers to the left and to the right of a keyword. If yes, then the
 keyword is not one}
function IsValid(letter1,letter2:byte):boolean;
begin
 result:=true;
 if ((letter1>=48) and (letter1<=57)) or ((letter1>=65) and (letter1<=90))
    or ((letter1>=97) and (letter1<=122)) then result:=false;
 if ((letter2>=48) and (letter2<=57)) or ((letter2>=65) and (letter2<=90))
    or ((letter2>=97) and (letter2<=122)) then result:=false;
end;

{finds the keywords and formats them}
function highlight(var text:string;keyword:string):string;
var stapos   :longint;
    endpos   :longint;
    actpos   :longint;
begin
 stapos:=0;
 endpos:=length(text);
  repeat
   actpos:=such(text,keyword,stapos);
   if actpos <> -1 then
     begin
       if IsValid(ord(text[actpos-1]),ord(text[actpos+length(keyword)])) and (not IsInaRegion(actpos)) then
        begin
          Insert('[/b]',text,actpos+length(keyword));
          Insert('[b]' ,text,actpos);
          setze_regionen(text);
          stapos:=actpos+2+length(keyword);
        end
        else stapos:=actpos+2;
     end;
 until actpos=-1;
 result:=text;
end;


{this functions styles all the regions italic (except the '..' regions) and calls the highlight function}
function parsen(var text:string):string;
var i:longint;
begin
 setze_regionen(text);
 for i:=0 to high(region.slash) do
  begin
    setze_regionen(text);
    Insert('[/i]',text,region.slash[i].y);
    Insert('[i]',text,region.slash[i].x);
  end;
 for i:=0 to high(region.gklam) do
  begin
    setze_regionen(text);
    Insert('[/i]',text,region.gklam[i].y+1);
    Insert('[i]',text,region.gklam[i].x);
  end;
 for i:=0 to high(region.stern) do
  begin
    setze_regionen(text);
    Insert('[/i]',text,region.stern[i].y+2);
    Insert('[i]',text,region.stern[i].x);
  end;
 for i:=0 to length(kwords)-1 do highlight(text,kwords[i]);
 result:=text;
end;

{a copy of the stringreplace function to avoid linking the sysutils.pas
 which would unnecessarily blow up the whole program a lot}
function StringReplace(var text:string; oldsub, newsub: string): string;
var stapos   :longint;
    endpos   :longint;
    actpos   :longint;
begin
 stapos:=0;
 endpos:=length(text);
  repeat
   actpos:=such(text,oldsub,stapos);
   if actpos <> -1 then
     begin
       Delete(text, actpos, length(oldsub));
       Insert(newsub,text,actpos);
       stapos:=actpos+1;
     end;
  until actpos=-1;
  result:=text;
end;

{this function replaces all pseudotags, for eample array[i]}
function ersetze_tags(var text:string):string;
begin
 stringreplace(text,'[i]'      ,'&#091;i&#093;');
 stringreplace(text,'[/i]'     ,'&#091;/i&#093;');
 stringreplace(text,'[b]'      ,'&#091;b&#093;');
 stringreplace(text,'[/b]'     ,'&#091;/b&#093;');
 stringreplace(text,'[code]'   ,'&#091;code&#093;');
 stringreplace(text,'[/code]'  ,'&#091;/code&#093;');
 stringreplace(text,'[img]'    ,'&#091;img&#093;');
 stringreplace(text,'[/img]'   ,'&#091;/img&#093;');
 stringreplace(text,'[quote]'  ,'&#091;quote&#093;');
 stringreplace(text,'[/quote]' ,'&#091;/quote&#093;');
 stringreplace(text,'[email]'  ,'&#091;email&#093;');
 stringreplace(text,'[/email]' ,'&#091;/email&#093;');
 stringreplace(text,'[list]'   ,'&#091;list&#093;');
 stringreplace(text,'[/list]'  ,'&#091;/list&#093;');
 stringreplace(text,'[url]'    ,'&#091;url&#093;');
 stringreplace(text,'[/url]'   ,'&#091;/url&#093;');
 result:=text;
end;

{takes care that all the empty lines appear in the forum, too}
function lineformat(var text:string):string;
var stapos   :longint;
    endpos   :longint;
    actpos   :longint;
begin
 stapos:=0;
 endpos:=length(text);
  repeat
   actpos:=such(text,#13#10#13#10,stapos);
   if actpos <> -1 then
     begin
       Insert(#13#10,text,actpos);
       stapos:=actpos+6;
     end;
  until actpos=-1;
  result:=text;
end;

{this function calls all the others}
function formatiere(var rtext:string):string;
var hclip    :THandle;
    pclip    :pchar;
begin
 lineformat(rtext);
 rtext:=ersetze_tags(rtext);
 Insert('[CODE]',rtext,0);
 rtext:=parsen(rtext);
 Insert('[/CODE]',rtext,length(rtext));

 OpenClipboard(0);                                              //open the clipboard
 EmptyClipboard;                                                     //empty the clipboard
 hclip:=GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE,length(rtext)+1); //allocate memory in heap
 pclip:=GlobalLock(hclip);                                           //get the pointer to the block of memory
 ZeroMemory(pclip,length(rtext)+1);                                  //zero out the memory
 MoveMemory(pclip,pchar(rtext),length(rtext)+1);                     //copy the text in
 SetClipBoardData(CF_TEXT,hclip);                                    //associate the block of memory to the clipboard
 CloseClipboard;                                                     //close the clipboard
 Globalfree(hclip);                                                  //free the block of memory
 result:=rtext;
end;

end.
 